<template>
	<q-page class="bg-secondary flex flex-center">
		<div style="background-color:#F0EEED;width:400px;font-family:verdana">
			<q-form
				ref="resetValidation"
				v-if="currentForm === 1"
				class="q-ma-xl">
				<h2 class="text-h2 text-size-18 text-center text-weight-bold q-ma-none">
					ADD A USER
				</h2>
				<q-input
			
					v-model="form.name"
					label="Name"
					hint="Ex. Juan Dela Cruz"
					style="width: 300px"
					hide-hint
					lazy-rule
					dense
					:rules="[requiredInput()]"
				>
				</q-input>
				<q-input
					v-model="form.username"
					label="Username"
					style="width: 300px;"
					hide-hint
					lazy-rule
					dense
					bottom-slots
					:rules="[requiredInput(), validateUsername()]"
				>
				</q-input>
				<q-input
					v-model="form.email"
					label="Email"
					style="width: 300px"
					hide-hint
					lazy-rule
					type="email"
					dense
					bottom-slots
					:rules="[requiredInput(), validateEmail()]"
				>
				</q-input>
				<q-input
					v-model="form.phone"
					label="Phone Number"
					style="width: 300px"
					mask="(+639) ### - #### - ###"
					hint="(+639) ### - #### - ###"
					unmasked-value
					hide-hint
					lazy-rule
					dense
					bottom-slots
					:rules="[requiredInput()]"
				>
				</q-input>
				<q-input
					v-model="form.website"
					label="Website"
					style="width: 300px"
					hide-hint
					lazy-rule
					dense
					bottom-slots
					hint="Ex. websitename.com"
					:rules="[requiredInput(), validateWebsite()]"
				>
				</q-input>
				<div class="text-right">
					<q-btn
						label="Next"
						color="black"
						style="width: 180px;margin-right:60px"
						push
						:disable="btnUserFormState"
						@click="currentForm = 2"
					/>
				</div>
			</q-form>
			<q-form
				ref="resetValidation"
				v-if="currentForm === 2"
				class="q-ma-xl"
			>
				<h2
					class="text-h2 text-size-18 text-center text-weight-bold q-ma-none"
				>
					USER ADDRESS
				</h2>

				<q-input
					v-model="form.address.street"
					label="Street"
					style="width: 300px"
					hide-hint
					lazy-rule
					dense
					bottom-slots
					:rules="[requiredInput()]"
				>
				</q-input>
				<q-input
					v-model="form.address.suite"
					label="Suite"
					style="width: 300px"
					hide-hint
					lazy-rule
					dense
					bottom-slots
					:rules="[requiredInput()]"
				>
				</q-input>
				<q-input
					v-model="form.address.city"
					label="City"
					style="width: 300px"
					hide-hint
					lazy-rule
					dense
					bottom-slots
					:rules="[requiredInput()]"
				>
				</q-input>
				<q-input
					type="number"
					v-model="form.address.zipcode"
					label="Zip Code"
					style="width: 300px"
					hide-hint
					lazy-rule
					dense
					bottom-slots
					:rules="[requiredInput()]"
				>
				</q-input>
				<q-input
					v-model="form.address.geo.lat"
					label="Latitude"
					type="number"
					style="width: 300px"
					hide-hint
					lazy-rule
					dense
					bottom-slots
					:rules="[requiredInput(), validateLatLng()]"
				>
				</q-input>
				<q-input
					type="number"
					v-model="form.address.geo.lng"
					label="Longitude"
					style="width: 300px"
					hide-hint
					lazy-rule
					dense
					bottom-slots
					:rules="[requiredInput(), validateLatLng()]"
				>
				</q-input>
				<div class="text-right">
					<q-btn
						label="Back"
						color="black"
						style="width: 120px; margin-right: 60px"
						push
						@click="currentForm = 1"
					/>
					<q-btn
						label="Next"
						color="red"
						style="width: 120px"
						push
						:disable="btnAddressState"
						@click="currentForm = 3"
					/>
				</div>
			</q-form>
			<q-form
				ref="resetValidation"
				v-if="currentForm === 3"
				class="q-ma-xl"
			>
				<h2
					class="text-h2 text-size-18 text-center text-weight-bold q-ma-none"
				>
					COMPANY 
				</h2>
				<q-input
					v-model="form.company.name"
					label="Company Name"
					style="width: 300px"
					hide-hint
					lazy-rule
					dense
					bottom-slots
					:rules="[requiredInput()]"
				>
				</q-input>
				<q-input
					v-model="form.company.catchPhrase"
					label="Catch Phrase"
					style="width: 300px"
					hide-hint
					lazy-rule
					dense
					bottom-slots
					:rules="[requiredInput()]"
				>
				</q-input>
				<q-input
					v-model="form.company.bs"
					label="BS"
					style="width: 300px"
					hide-hint
					lazy-rule
					dense
					bottom-slots
					:rules="[requiredInput()]"
				>
				</q-input>
				<div class="text-right">
					<q-btn
						label="Back"
						color="black"

						style="width: 120px; margin-right: 60px"
						push
						@click="currentForm = 2"
					/>
					<q-btn
						label="SUBMIT"
						color="red"

						style="width: 120px"
						push
						:loading="btnLoadingState"
						:disable="btnCompanyState"
						@click="addUserData()"
					/>
				</div>
			</q-form>
		</div>
	</q-page>
</template>

<script>
import { ref } from "vue";
import {
	addUserData,
	resetValidation,
	requiredInput,
	validateEmail,
	validateWebsite,
	validateUsername,
	validateLatLng,
	userFormValidation,
	btnUserFormState,
	btnAddressState,
	btnLoadingState,
	btnCompanyState,
} from "../composables/data";

let form = ref({
	id: null,
	name: null,
	username: null,
	email: null,
	address: {
		street: null,
		suite: null,
		city: null,
		zipcode: null,
		geo: {
			lat: null,
			lng: null,
		},
	},
	phone: null,
	website: null,
	company: {
		name: null,
		catchPhrase: null,
		bs: null,
	},
});

let currentForm = ref(1);
export default {
	setup() {
		return {
			resetValidation,
			form,
			currentForm,
			addUserData,
			requiredInput,
			validateEmail,
			validateWebsite,
			validateUsername,
			validateLatLng,
			btnUserFormState,
			userFormValidation,
			btnLoadingState,
			btnAddressState,
			btnCompanyState,
		};
	},
};

export { form, currentForm };
</script>

<style>
.text-size-18 {
	font-size: 18px;
	color: ;
}
</style>
